//+------------------------------------------------------------------+
//|                                               Slope_EA_RB_V2.mq4 |
//|                            Rogerio Borges, Copyright 2016        |
//|                                          rogeriob28@gmail.com    | 
//+------------------------------------------------------------------+
#property copyright "Rogerio Borges,Copyright 2016"
#property link      "rogeriob28@gmail.com"

extern string Comentario = "Slope EA V2 ";
extern string S1="----Slope Entry Settings";
extern int period=80; 
extern int method=3; // MODE_SMA 
extern int price=0; // PRICE_CLOSE 

//Initial Stop Loss
extern string  InitialStopLossExp = "<<< Initial Stop Loss >>>";
extern string  AboutInitialStopLoss = "---  You can change Initial StopLoss Method ---";
extern string  InitialStop_note = "0=Fake(No_SL),  1=ATR_Multiple_SL,  2=FixPips_SL";
extern int     InitialStop_Method = 2;
extern double  InitialStopATR = 1.7;
extern int     InitialStopPips = 10;

//Trailing Stop
extern string  TrailMethodExp = "<<< Trailing Stop Method >>>";
extern string  AboutTrail_Method = "--- You can change Trailing Method ---";
extern string  Trail_Method_note = "0=Trail_OFF, 1=ATR_Mode, 2=FixPips_Mode, 3=Profit_Mode";
extern int     TRAIL_MODE = 1.2;

extern string  AboutTrail_Method1 = "--- 1. You can change Trailing ATR Multiple ---";
extern double  Trail_ATR = 2.5;
extern string  AboutTrail_Method2 = "--- 2. You can change Trailing Pips ---";
extern int     Trail_Pips = 100;
extern string  AboutTrail_Method3 = "--- 3. You can change Trailing Profit to Reserve ---";
extern double  Profit_to_Reserve = 0.5;

//PositionSizing
extern string  PSExp = "<<< Position Sizing >>>";
extern double  FixLot=0.1; // if you don't use PS, this lot size is used.
extern bool    PositionSizing = true ;
extern double  PS_RiskRate = 0.8;
extern int     ATR_Period=30;

extern int MagicNumber=10001;
extern double Lots =1;
extern int Slippage=1;
extern int Start_Time=0;
extern int Finish_Time=0;

//EA name
string  EANAME="SlopeDirectionLine";
string  EASHORTNAME="SlopeDirLine";


//+------------------------------------------------------------------+
//    expert start function
//+------------------------------------------------------------------+
int start()
{
//Get Current Position
   int pos = CalculateCurrentOrders();

 // Trailing Stop
   if(TRAIL_MODE>3 || TRAIL_MODE<0) TRAIL_MODE = 1; // error correction
   if( (pos > 0 || pos < 0) && TRAIL_MODE != 0 ) MultiModeTrailingStop();
   
//Entry_Logic
      //Culclate Indicator
   double SDL_Up = iCustom(NULL, 0, "Slope Direction Line Modified", period, method, price, 0, 1); //Uptrend of Previous Bar
   double SDL_Dn = iCustom(NULL, 0, "Slope Direction Line Modified", period, method, price, 1, 1); //Dntrend of Previous Bar 
   

// Buy and Sell Close Condition   
 for(int index=OrdersTotal()-1; index>=0; index--)
   {
   OrderSelect(index,SELECT_BY_POS,MODE_TRADES);
   if((OrderSymbol()==Symbol()) && (OrderMagicNumber()==MagicNumber))
   {
      
   
    if(OrderType()==OP_BUY && SDL_Up > SDL_Dn)
   {
      OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),Slippage,Green);
   }
   
   if(OrderType()==OP_SELL && SDL_Up < SDL_Dn)
   {
      OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK),Slippage,Orange);
   }
   }
   }


// Buy and Sell Open 
  double MyPoint=Point;
  if(Digits==3 || Digits==5) MyPoint=Point*10;

  if(TotalOrdersCount()==0 && AllowTradesByTime()==True) 
  {
     int result=0;

     
     if(SDL_Up < SDL_Dn) // // Here is your open buy rule
     {
        result=OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,0,0,Comentario,MagicNumber,0,Blue);
        
     }
     
     if(SDL_Up > SDL_Dn) // Sell
     {
        result=OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,0,0,Comentario,MagicNumber,0,Red); // Here is your open Sell rule
        
    }
  }
  return(0);
}


// Hour to Trade
bool AllowTradesByTime()
   {
      int Current_Time = TimeHour(TimeCurrent());
   if (Start_Time == 0) Start_Time = 24; if (Finish_Time == 0) Finish_Time = 24; if (Current_Time == 0) Current_Time = 24;
      
   if ( Start_Time < Finish_Time )
      if ( (Current_Time < Start_Time) || (Current_Time >= Finish_Time) ) return(false);
      
   if ( Start_Time > Finish_Time )
      if ( (Current_Time < Start_Time) && (Current_Time >= Finish_Time) ) return(false);
      
   return(true);
   }

// Total Orders
int TotalOrdersCount()
{
  int result=0;
  for(int i=0;i<OrdersTotal();i++)
  {
     if(OrderSelect(i,SELECT_BY_POS ,MODE_TRADES))
     {
      if (OrderMagicNumber()==MagicNumber && OrderSymbol()==Symbol()) result++;
     }
  }
  return (result);
}

//--------------------------- Indicators -----------------------------
//+------------------------------------------------------------------+
//| Slope Direction Line function                                    |
//+------------------------------------------------------------------+
string Slope()
  {
  
//Uptrend = iCustom( NULL, 0, "SlopeqDirectiontLine", period, method, price, 0, 0 ); // BUFFER 0 - LightBlue
//Dntrend = iCustom( NULL, 0, "SlopeqDirectiontLine", period, method, price, 1, 0 ); // BUFFER 1 - Tomato
   double Up = iCustom(NULL,0,"slope-direction-line",period, method, price, 0, 0);
   double Dn = iCustom(NULL,0,"slope-direction-line",period, method, price, 1, 0);

   if(Up<Dn) return(1);      // Slope Direction Blue
   if(Up>Dn) return(2);      // Slope Direction Red

   else return(-1);
   

   
  }
 //+------------------------------------------------------------------+
//| Initial Stop                                                     |
//+------------------------------------------------------------------+ 
  double InitialStop()
{
   double InitStop = 0;

   if(InitialStop_Method>2 || InitialStop_Method<0) InitialStop_Method = 1; // error correction
   if(InitialStop_Method == 1) InitStop = iATR(NULL,0,ATR_Period,1) * InitialStopATR ;
   if(InitialStop_Method == 2) InitStop = InitialStopPips ;
   return(InitStop);
}


//+------------------------------------------------------------------+
//| profit_unit                                                      |
//+------------------------------------------------------------------+
double profit_unit()
{
    double lot_size    =MarketInfo(Symbol(),MODE_LOTSIZE); //
    string base_currecy=StringSubstr(Symbol(),0,3);
    int    symbol_len  =StringLen(Symbol());
    string term_currecy="USD";
    if(symbol_len==6)
        term_currecy=StringSubstr(Symbol(),3,3);
    string term_pair =term_currecy+AccountCurrency();
    string xterm_pair=AccountCurrency()+term_currecy;
    string base_pair =base_currecy+AccountCurrency();
    double term_unit =1.0;
    if(base_currecy==AccountCurrency())
    { 
        term_unit=1.0/Bid;
    }
    else if(term_currecy!=AccountCurrency())
    {
        term_unit=iClose(term_pair,0,0);
        if(term_unit<=0)
        {
            term_unit=iClose(xterm_pair,0,0);
            if(term_unit<=0)
            {
                term_unit=iClose(base_pair,0,0);
            }
            else
            {
               term_unit=1.0/term_unit;
            }
        }
    }
    return(lot_size*Point*term_unit); // returns Profit/Loss per 1.0 lot * 1pip by your accout currency.
}


//+------------------------------------------------------------------+
//| MultiModeTrailingStop                                            |  TRAIL_MODE   0=Trail_OFF, 1=ATR_Mode, 2=FixPips_Mode, 3=Profit_Mode 
//+------------------------------------------------------------------+
void MultiModeTrailingStop()
{
   int pos,i;
   double STOP, CurrentSL, STOP_HABA, Profit;
   bool selected;

   pos = CalculateCurrentOrders();

   // Get Current Stop Loss
   CurrentSL = CheckCurrentStop();

   if(TRAIL_MODE == 1) STOP_HABA = iATR(NULL,0,ATR_Period,1)*Trail_ATR ;
   if(TRAIL_MODE == 2) STOP_HABA = Trail_Pips * Point ;

if(pos > 0) //Buy Position ------------------------------------------------------------------------------
{
   if( (TRAIL_MODE == 1 || TRAIL_MODE == 2) && Close[1] - STOP_HABA > CurrentSL) // if ATR or Fixpips Mode
   {
      STOP = Close[1] - STOP_HABA ;
   
      // Modify Stop Loss (Buy --- ATR/FIX)
      for(i=0; i<OrdersTotal(); i++)
      {
         selected = OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
         if(selected && OrderMagicNumber() == MagicNumber && OrderSymbol() == Symbol() && OrderType() == OP_BUY)
         {
            OrderModify(OrderTicket(),OrderOpenPrice(),STOP,0,0,Violet);
         }
      }
   return(0);
   }

   if(TRAIL_MODE == 3) // if ProfitMode
   {
      Profit = Bid - CurrentSL; // Culculate Current Profit by pips
      STOP = Bid - (Profit * Profit_to_Reserve);
   
      // Modify Stop Loss (Buy --- Profit)
      for(i=0; i<OrdersTotal(); i++)
      {
         selected = OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
         if(selected && OrderMagicNumber() == MagicNumber && OrderSymbol() == Symbol() && OrderType() == OP_BUY)
         {
            OrderModify(OrderTicket(),OrderOpenPrice(),STOP,0,0,Violet);
         }
      }
   return(0);
   }

} // end of Buy Trailing --------------------------------------------------------------------------------

if(pos < 0) //Sell Position
{
   // Modify Stop Loss
   if( (TRAIL_MODE == 1 || TRAIL_MODE == 2) && Close[1] + STOP_HABA < CurrentSL) // if ATR or Fixpips Mode
   {
      STOP = Close[1] + STOP_HABA ;

      // Modify Stop Loss (Sell --- ATR/FIX)
      for(i=0; i<OrdersTotal(); i++)
      {
         selected = OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
         if(selected && OrderMagicNumber() == MagicNumber && OrderSymbol() == Symbol() && OrderType() == OP_SELL)
         {
            OrderModify(OrderTicket(), OrderOpenPrice(),STOP,0,0,Yellow);
         }
      }
   return(0);
   }

   if(TRAIL_MODE == 3) // if ProfitMode
   {
      // Modify Stop Loss
      Profit = CurrentSL - Ask ; // Get Current Stop Loss
      STOP = Ask + (Profit * Profit_to_Reserve);

      // Modify Stop Loss (Sell --- Profit)
      for(i=0; i<OrdersTotal(); i++)
      {
         selected = OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
         if(selected && OrderMagicNumber() == MagicNumber && OrderSymbol() == Symbol() && OrderType() == OP_SELL)
         {
            OrderModify(OrderTicket(), OrderOpenPrice(),STOP,0,0,Yellow);
         }
      }
   }

} // end of Sell Trailing --------------------------------------------------------------------------------

} // end of MultiModeTrailing()


//+------------------------------------------------------------------+
//| Get Current StopLoss                                             |
//+------------------------------------------------------------------+
double CheckCurrentStop()
{
   int pos,i;
   double Profit, STOP, CurrentSL;
   bool selected;
   
   pos = CalculateCurrentOrders();

   if(pos>0) // Buy
   {
      CurrentSL = 0;
      // Get Current StopLoss
      for(i=0; i<OrdersTotal(); i++)
      {
         selected = OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
         if(selected && OrderMagicNumber() == MagicNumber && OrderSymbol() == Symbol() && OrderType() == OP_BUY)
         {
            if(OrderStopLoss() > CurrentSL) CurrentSL = OrderStopLoss();
         }
      }
   return(CurrentSL);
   }
   
   if(pos<0) // Sell
   {
      CurrentSL = 10000;
      // Get Current StopLoss
      for(i=0; i<OrdersTotal(); i++)
      {
         selected = OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
         if(selected && OrderMagicNumber() == MagicNumber && OrderSymbol() == Symbol() && OrderType() == OP_SELL)
         {
            if(OrderStopLoss() < CurrentSL) CurrentSL = OrderStopLoss();
         }
      }
   return(CurrentSL);
   }   
} // end of CheckCurrentStop

//+------------------------------------------------------------------+
//| Culculate Current Open Position                                  |
//+------------------------------------------------------------------+
int CalculateCurrentOrders()
{
   //Open Positionsi+:Buy -:Sellj
   int i;
   int pos=0;

   // Buy Position
   int pos_buy=0;
   for(i=0; i<OrdersTotal(); i++)
   {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES) == false) break;
      if(OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
      {
         if(OrderType() == OP_BUY) pos_buy++ ;
      }
   }

   //Sell Position
   int pos_sell=0;
   for(i=0; i<OrdersTotal(); i++)
   {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES) == false) break;
      if(OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
      {
         if(OrderType() == OP_SELL) pos_sell--;
      }
   }

   //Culculate pos
   if(pos_buy>0) pos = pos_buy;
   if(pos_sell<0) pos = pos_sell;
   if(pos_sell == 0 && pos_buy == 0) pos = 0;

   return(pos);
} // end of CalculateCurrentOrders